<% if (section === 'css') { %>
<style>
    #youtube-player {
        position: fixed;
        top: 25%;
        left: 0;
    }

</style>
<% } %>

<% if (section === 'html') { %>
<div class="page" page="youtube">
    <div id="youtube-player"></div>
</div>
<% } %>

<% if (section === 'js') { %>
<script>
  const youtubeTag = document.createElement("script")

  youtubeTag.src = "https://www.youtube.com/iframe_api"
  const firstScriptTag = document.getElementsByTagName("script")[0]
  firstScriptTag.parentNode.insertBefore(youtubeTag, firstScriptTag)

  let youtubePlayer
  let youtubeIframe
  let youtubeReady = false
  let lastYoutubeId = ""
  function onYouTubeIframeAPIReady() {
    youtubePlayer = new YT.Player("youtube-player", {
      height: "75%",
      width: "100%",
      playerVars: { "autoplay": 0},
      events: {
        "onReady": onYoutubePlayerReady,
        "onStateChange": onYoutubePlayerStateChange
      }
    })
  }

  function onYoutubePlayerReady(event) {
    let youtubePlayer = event.target
    youtubeReady = true
    youtubeIframe = document.querySelector("#youtube-player")
    youtubePlayer.loadVideoById(lastYoutubeId)
    youtubePlayer.stopVideo()
  }
  function onYoutubePlayerStateChange(event) {
  }

  function youtubeLoadVideo(youtubeId) {
    if (youtubeId != lastYoutubeId) {
      lastYoutubeId = youtubeId;
      if (youtubeReady) {
        if (youtubeId == "") {
          youtubePlayer.stopVideo();
        } else {
          youtubePlayer.loadVideoById(youtubeId);
          console.log("New youtube video loaded.");
        }
      }
    }
  }

  function youtubeFullscreen(value) {
    if (value) {
      youtubeIframe.style.top = "0%";
      youtubeIframe.height = "100%";
    } else {
      youtubeIframe.height = "75%";
      youtubeIframe.style.top = "25%";
    }
  }

  registerCommand('youtube', 'setVideo', (data) => {
    youtubeLoadVideo(data.id)
  })
  
  registerCommand('youtube', 'fullscreen', (data) => {
    youtubeFullscreen(data.fullscreen)
  })

  registerCommand('youtube', 'start', () => {
    youtubePlayer.playVideo()
  })

  registerCommand('youtube', 'pause', () => {
    youtubePlayer.pauseVideo()
  })

  registerCommand('youtube', 'stop', () => {
    youtubePlayer.stopVideo()
  })

  registerCommand('youtube', 'plus10sec', () => {
    youtubePlayer.seekTo(youtubePlayer.getCurrentTime() + 10)
  })
  
  registerCommand('youtube', 'min10sec', () => {
    youtubePlayer.seekTo(youtubePlayer.getCurrentTime() - 10)
  })
</script>
<% } %>
